/// <reference types="react" />
import type { EmotionCache } from "@emotion/cache";
export type { CSSInterpolation, CSSObject, Css, Cx, CxArg } from "./types.mjs";
import { createMakeStyles, TssCacheProvider } from "./makeStyles.mjs";
export { createMakeStyles, TssCacheProvider };
import { createWithStyles } from "./withStyles_compat.mjs";
export { createWithStyles };
/** @see <https://docs.tss-react.dev/api/keyframes> */
export { keyframes } from "@emotion/react";
/** @see <https://docs.tss-react.dev/api/globalstyles> */
export { GlobalStyles } from "./GlobalStyles.mjs";
/** @see <https://docs.tss-react.dev/api/makestyles> */
export declare function createMakeAndWithStyles<Theme>(params: {
    useTheme: () => Theme;
    cache?: EmotionCache;
}): {
    withStyles: {
        <C extends keyof import("react").ReactHTML | import("./tools/ReactComponent.mjs").ReactComponent<any>, Props extends C extends import("./tools/ReactComponent.mjs").ReactComponent<infer P> ? P : C extends keyof import("react").ReactHTML ? import("react").ReactHTML[C] extends import("./tools/ReactComponent.mjs").ReactComponent<infer P_1> ? NonNullable<P_1> : never : never, CssObjectByRuleName extends Props extends {
            classes?: Partial<infer ClassNameByRuleName> | undefined;
        } ? { [RuleName in keyof ClassNameByRuleName]?: import("./types.mjs").CSSObject | undefined; } : {
            root: import("./types.mjs").CSSObject;
        }>(Component: C, cssObjectByRuleNameOrGetCssObjectByRuleName: CssObjectByRuleName | ((theme: Theme, props: Props, classes: Record<keyof CssObjectByRuleName, string>) => CssObjectByRuleName), params?: {
            name?: string | Record<string, unknown> | undefined;
            uniqId?: string | undefined;
        } | undefined): C extends keyof import("react").ReactHTML ? import("react").ReactHTML[C] : C;
        getClasses: <Classes>(props: {
            className?: string | undefined;
            classes?: Classes | undefined;
        }) => Classes extends Record<string, unknown> ? Classes extends Partial<Record<infer K, any>> ? Record<K, string> : Classes : {
            root: string;
        };
    };
    makeStyles: <Params = void, RuleNameSubsetReferencableInNestedSelectors extends string = never>(params?: {
        name?: string | Record<string, unknown> | undefined;
        uniqId?: string | undefined;
    } | undefined) => <RuleName_1 extends string>(cssObjectByRuleNameOrGetCssObjectByRuleName: Record<RuleName_1, import("./types.mjs").CSSObject> | ((theme: Theme, params: Params, classes: Record<RuleNameSubsetReferencableInNestedSelectors, string>) => Record<RuleNameSubsetReferencableInNestedSelectors | RuleName_1, import("./types.mjs").CSSObject>)) => (params: Params, styleOverrides?: {
        props: any;
        ownerState?: Record<string, unknown> | undefined;
    } | undefined) => {
        classes: Record<RuleName_1, string>;
        theme: Theme;
        css: import("./types.mjs").Css;
        cx: import("./types.mjs").Cx;
    };
    useStyles: () => {
        theme: Theme;
        css: import("./types.mjs").Css;
        cx: import("./types.mjs").Cx;
    };
};
